# External Entity (Consumer)

## Introduction

The **External Entity (Consumer)** module allows Drupal sites to consume and display content from external sources—most commonly another Drupal site running the [External Entity Server](https://www.drupal.org/project/external_entity_server). It lets site builders map external data to local Drupal entity types and render it using familiar tools like Views, view modes, and field formatters.

Unlike traditional data integrations that duplicate or migrate content, this module enables real-time, read-only rendering of remote content as if it lived locally—without decoupling or complex custom code.

For a full description of the module, visit the project page:  
https://www.drupal.org/project/external_entity

To submit bug reports and feature suggestions, or track changes:  
https://www.drupal.org/project/issues/external_entity

---

## Requirements

This module requires no modules outside of Drupal core.

---

## Recommended modules

- [External Entity Server](https://www.drupal.org/project/external_entity_server):  
  Used to expose Drupal entity data for consumption by this module.

---

## Installation

Install as you would normally install a contributed Drupal module. For further information, see:  
https://www.drupal.org/docs/extending-drupal/installing-drupal-modules

---

## Configuration

Once installed, follow these steps to configure External Entity (Consumer):

1. **Add a connection**  
   Navigate to: `/admin/config/services/external-entity/connection`  
   Set up a connection to your External Entity Server. Provide the remote domain and specify the authentication method, if required.

2. **Define External Entity Types**  
   Navigate to: `/admin/structure/external-entity/type`  
   Map remote entities to local entity types (e.g., map a remote `News` content type to a local `News` content type).  
   Configure the field mappings under *Manage Display* to determine how fields from the external source are rendered locally.

3. **Access and Use External Entities**  
   External content can be used in two ways:
   - **Entity Reference:** Use the External Entity reference field to attach and display external content using view modes.
   - **Views Integration:** Create External Entity Views to list and filter remote content using Drupal’s Views UI. Choose a view mode for rendering.

> Note: This module assumes that the external site has been properly configured with the External Entity Server module and is sharing one or more resources.

---

## Maintainers

- Travis Tomka ([droath](https://www.drupal.org/u/droath))

**Sponsored by:**  
- [Corning Museum of Glass](https://home.cmog.org)